volumes:
  task-application:
    external: true

services:
  postgres:
    build:
      context: ./relational-data
      dockerfile: ./Dockerfile.dev
    volumes:
      - task-application:/var/lib/postgresql/data
    environment:
      - POSTGRES_MULTIPLE_DATABASES=tasks_repo,users_repo
      - POSTGRES_PASSWORD=task-databases
    ports:
     - 15432:5432
  
  react:
    image: node:lts-bullseye
    command: /bin/bash run.sh
    working_dir: /app
    volumes:
      - ./react_frontend:/app
    ports:
      - "3000:3000"
    environment:
      HOST_OS: ${OS}
      NODE_ENV: development
      HOST: "0.0.0.0"
      REACT_APP_TASKS: http://localhost:8000/
      REACT_APP_USERS: http://localhost:8080/
      REACT_APP: http://localhost:3000/
    
  tasks-repo:
    build:
      context: ./Tasks_Repo
      dockerfile: ./Dockerfile.dev
    ports:
      - "8000:8000"
    volumes:
      - ./Tasks_Repo:/app
    environment:
      DATABASE_URL: postgresql://tasks_repo:password@postgres:5432/tasks_repo
      WAIT_HOSTS: postgres:5432
      DJWTO_SIGNING_KEY: ${DJWTO_SIGNING_KEY}
  
  users-repo:
    build: 
      context: ./Users_Repo
      dockerfile: ./Dockerfile.dev
    ports:
      - "8080:8000"
    volumes:
      - ./Users_Repo:/app
    environment:
      DATABASE_URL: postgresql://users_repo:password@postgres:5432/users_repo
      WAIT_HOSTS: postgres:5432
      DJWTO_SIGNING_KEY: ${DJWTO_SIGNING_KEY}

  rabbitmq:
    image: rabbitmq:3

  userfanout:
    build:
        context: ./Tasks_Repo/Consumer
        dockerfile: ./Dockerfile.dev
    volumes:
        - ./Tasks_Repo/Consumer:/app
        - ./Tasks_Repo/Tasks_Project:/app/Tasks_Project
        - ./Tasks_Repo/Tasks_App:/app/Tasks_App
    depends_on:
        - postgres
        - tasks-repo
        - rabbitmq
    environment:
        DATABASE_URL: postgresql://tasks_repo:password@postgres:5432/tasks_repo
        WAIT_HOSTS: postgres:5432, tasks-repo:8000
        WAIT_TIMEOUT: 600

  
  taskfanout:
    build:
      context: ./Users_Repo/Consumer
      dockerfile: ./Dockerfile.dev
    volumes:
      - ./Users_Repo/Consumer:/app
      - ./Users_Repo/Users_Project:/app/Users_Project
      - ./Users_Repo/Users_App:/app/Users_App
    depends_on:
      - postgres
      - users-repo
      - rabbitmq
    environment:
      DATABASE_URL: postgresql://users_repo:password@postgres:5432/users_repo
      WAIT_HOSTS: postgres:5432, users-repo:8000
      WAIT_TIMEOUT: 600

  duedatenotificationpoller:
    build:
      context: ./Users_Repo/Poller
      dockerfile: ./Dockerfile.dev
    volumes:
      - ./Users_Repo/Poller:/app
      - ./Users_Repo/Users_Project:/app/Users_Project
      - ./Users_Repo/Users_App:/app/Users_App
    depends_on:
      - postgres
      - users-repo
      - tasks_repo
    environment:
      DATABASE_URL: postgresql://users_repo:password@postgres:5432/users_repo
      WAIT_HOSTS: postgres:5432, users-repo:8000, tasks-repo:8000
      WAIT_TIMEOUT: 600
      TASKS_API: http://tasks-repo:8000

